Subject: Re: [PATCH v4] diff: stop output garbled message in dry run mode

From: Junio C Hamano <[email-masked]>
Date: Wed, 22 Oct 2025 14:33:26 -0700

Junio C Hamano <[email-masked]> writes:

> Lidong Yan <[email-masked]> writes:
> ...
>> +	test_diff_no_content_changes () {
>> +		git diff $1 --ignore-blank-lines -I".*" >actual &&
>> +		test_line_count = 3 actual &&
>> +		test_grep "file1" actual &&
>> +		test_grep "file2" actual &&
>> +		test_grep "file3" actual &&
>
> I am puzzled by this part of the new test.
>
>> +		test_grep ! "diff --git" actual
>
> The "test_grep !" is to make sure we do not leak the "patch" output
> run in diff_flush_patch_quietly(), which is understandable, but in
> the new world order that even raw, name-only, and name-status honor
> "diff-from-contents" since b55e6d36 (diff: ensure consistent diff
> behavior with ignore options, 2025-08-08), shouldn't we expect empty
> "actual" that does not say file1/file2/file3 in it?
>
>> +	} &&
>> +	test_diff_no_content_changes "--raw" &&
>> +	test_diff_no_content_changes "--name-only" &&
>> +	test_diff_no_content_changes "--name-status" &&

I think this was due to the lack of /dev/null redirect around the
other call site of diff_flush_patch_quietly().  I've rearranged
patches in this order:

 * Peff's /dev/null redirect for --quiet (NO_OUTPUT) codepath around
   diff_flush_patch_quietly();

 * My /dev/null redirect for --raw/--name-only/--name-status
   codepath around diff_flush_patch_quietly() on top of the above;

 * This patch with tests on top of the above.

And that was when I noticed the above test that expects 3 output
lines was fishy.

I have the following patch on top of your patch that started this
thread to queue it in 'seen' and have tests pass for today's
integration result.

 t/t4013-diff-various.sh | 6 +-----
 1 file changed, 1 insertion(+), 5 deletions(-)

diff --git a/t/t4013-diff-various.sh b/t/t4013-diff-various.sh
index d35695f5b0..c0a558da55 100755
--- a/t/t4013-diff-various.sh
+++ b/t/t4013-diff-various.sh
@@ -683,11 +683,7 @@ test_expect_success 'diff -I<regex>: ignore all content changes' '
 
 	test_diff_no_content_changes () {
 		git diff $1 --ignore-blank-lines -I".*" >actual &&
-		test_line_count = 3 actual &&
-		test_grep "file1" actual &&
-		test_grep "file2" actual &&
-		test_grep "file3" actual &&
-		test_grep ! "diff --git" actual
+		test_must_be_empty actual
 	} &&
 	test_diff_no_content_changes "--raw" &&
 	test_diff_no_content_changes "--name-only" &&
-- 
2.51.1-638-ge1c807bd82